<?php
ob_start();
 /*
* Plugin Name: Category Content (Widget)
* Plugin URI: http://online-source.net/2010/11/09/category-content/
* Description: Show more category content on your Wordpress blog | <a href="http://online-source.net/forums/forum/support/wordpress-plugins/" title="Online Source Wordpress plugins Support Forum">Support Forum</a>
* Author: Laurens ten Ham (MrXHellboy)
* Version: 2.0
* Author URI: http://online-source.net
*/

class CategoryContent extends WP_Widget
{
	function CategoryContent()
	{
		$widget_ops = array( 'classname' => 'widget_category_content', 'description' => 'Category Content' );
		$this->WP_Widget( 'category_content', 'Category Content', $widget_ops );
	}

	function widget( $args, $instance )
	{
	   global $wp_query;
        if (is_category())
            $this->category_content_set_cookie($wp_query->query_vars['cat']);
            
		if ( ( is_single() && $instance['show_on'] == 'single' ) xor ( is_category() && $instance['show_on'] == 'category' ) 
                xor ( ( is_category() || is_single() ) && $instance['show_on'] == 'both' ) )
		{       
			# Extract the arguments
			extract( $args );
            
            # Display widget - so do not ignore
            $ignore_widget = false;
            
			# Create array to store all the id's in
			$IDS = array();

			# Get the categorys
			$cats = get_the_category();
            
            # cat IDs from the categorys given to exclude entirely
            $ex_cats = explode(',', $instance['exclude_cats']);
            
            # If category - Get the first object only (current category)
            if (!is_category()): # Single
                if ($instance['show_last_viewed_cat'] == 'no'):
                    $IDS = $this->category_content_get_ids($cats, $instance, $IDS, $ex_cats);
                elseif ($instance['show_last_viewed_cat'] == 'yes' && (count($cats) > 1)):
                    if (@$_COOKIE['category_content'] == '' || !array_key_exists('category_content', @$_COOKIE)){
                        $IDS = $this->category_content_get_ids($cats, $instance, $IDS, $ex_cats);
                    } else {
                        $IDS[] = @$_COOKIE['category_content'];
                    }
                else:
                    $IDS = $this->category_content_get_ids($cats, $instance, $IDS, $ex_cats);
                endif;
                
            else: #Category
                // Get category ID if category
                if (in_array(get_query_var('cat'), $ex_cats) && ($instance['exclude_on'] == 'category' || $instance['exclude_on'] == 'both')):
                    $ignore_widget = true;
                else:
                    $IDS[] = get_query_var('cat');
                endif;
            endif;
            
            # If the widhet must be ignored or if all the related categories are excluded
            if ($ignore_widget || count($IDS) == 0)
                return '';
                
			# Get the categorys
			$CatID = implode( ',', $IDS );

			# Get the category title(s)
			$CatTitles = '';
			foreach ( $IDS as $id ) $CatTitles .= get_cat_name( $id ) . ', ';
            
			# Set childeren empty arrays
			$ChildIDS = array();
			$Child_Info = array();

			# Foreach Category ID ($IDS) get child info
			foreach ( $IDS as $Current_ID ) $Child_Info = array_merge( $Child_Info, get_categories( array( 'child_of' => $Current_ID ) ) );
            
			if ( count( $Child_Info ) > 0 )
			{
				# Foreach Child info, filter the cat ids.
				foreach ( $Child_Info as $child ) $ChildIDS[] = $child->cat_ID;
			}

			# Post arguments - category ids
			$category = ( $instance['remove_childs'] == 'on' ) ? $CatID . ',-' . implode( ',-', $ChildIDS ) : $CatID;
            
            if (is_single())
                $orderby =  strip_tags( $instance['orderby_single'] );
            else
                $orderby = strip_tags( $instance['orderby_cat'] );
                
            if (is_single())
                $order =  strip_tags( $instance['order_single'] );
            else
                $order = strip_tags( $instance['order_cat'] );            

            $args = array('year' => $instance['show_year'], 'orderby' => $orderby, 'order' => $order, 'post_type' => 'any', 'post_status' => 'publish', 'numberposts' => strip_tags( $instance['amount'] ), 'category' => $category );
            
            echo $before_widget;
            
            # Decide the categories must be shown after the title field
            $title = $before_title . strip_tags( $instance['title'] ) . '&nbsp;';
            
            if ($instance['show_cats'] == 'yes')
                $title .= rtrim( $CatTitles, ', ' );
                
            $title .= $after_title;
            
            
            echo $title;
            
            if ($instance['sticky_posts_on_top'] == 'yes'){
                $args['post__not_in'] = get_option('sticky_posts');
            }
            
            wp_reset_query();    
            $QueryPosts = get_posts( $args );
            
            # Start Sticky
            if ($instance['sticky_posts_on_top'] == 'yes'){
                $sticky_posts = array();
                    $sticky_args = array('post__in' => get_option('sticky_posts'),  'year' => $instance['show_year'], 'orderby' => $orderby, 'order' => $order, 'post_type' => 'any', 'post_status' => 'publish', 'numberposts' => strip_tags( $instance['amount'] ), 'category' => $category );
                wp_reset_query();
                $sticky_posts = get_posts( $sticky_args );
                
                if ($instance['amount'] == '-1'){
                    $instance['amount'] = count($QueryPosts)+count($sticky_posts);
                }

                /* START MANUAL ORDER */
                $sticky_posts_d = array();
                foreach ($sticky_posts as $s){
                    switch ($orderby):
                        case ($orderby == 'author'):
                            $sticky_posts_d[$s->post_author] = $s;
                            break;
                        case ($orderby == 'date'):
                            $sticky_posts_d[$s->post_date] = $s;
                            break;
                        case ($orderby == 'ID'):
                            $sticky_posts_d[$s->ID] = $s;
                            break;
                        case ($orderby == 'rand'):
                            $sticky_posts_d[$s->ID] = $s;
                            break;
                    endswitch;
                }
                
                $keys = array_keys($sticky_posts_d);
                
                if ($orderby != 'rand'){
                    switch ($order):
                        case ($order == 'ASC'):
                            @sort($keys, SORT_NATURAL);
                            break;
                        case ($order == 'DESC'):
                            @rsort($keys, SORT_NATURAL);
                            break;
                    endswitch;
                }
                
                $a = array();
                    foreach ($keys as $index => $d){
                        $a[] = $sticky_posts_d[$d];
                    }
                $sticky_posts = $a;
                
                # reverse the array because array_unshift start at the highest key
                @krsort($sticky_posts);
                foreach ($sticky_posts as $stick){
                    @array_unshift($QueryPosts, $stick);
                }
                    if (count($sticky_posts) == count($QueryPosts)){
                        $QueryPosts = $sticky_posts;
                    } else {
                        $QueryPosts = array_slice($QueryPosts, 0, (int)$instance['amount']);
                    }
            } # End sticky
            
			echo '<ul>';
			foreach ( $QueryPosts as $epost )
			{
			    $liclass = (is_single() && $wp_query->post->ID == $epost->ID) ? 'category-current-item' : 'category-item';
				# List item
				echo '<li class="'.$liclass.'"><a href="' . get_permalink($epost->ID) . '" title="' . $epost->post_title . '">' . $epost->post_title . '</a></li>';
			}

			echo '</ul>';

			echo $after_widget;
		}
	}
    
    private function category_content_get_ids($cats, $instance, $IDS, $ex_cats){
                    # Get all the IDS
                    foreach ( $cats as $cat ):
                        $IDS[] = $cat->cat_ID;
                    endforeach;
                
                        if ($instance['exclude_on'] == 'single' || $instance['exclude_on'] == 'both'):
                            #Remove the requested categories to be excluded
                                foreach ($IDS as $index => $id):
                                    if (in_array($id, $ex_cats)):
                                        unset($IDS[$index]);
                                    endif;
                                endforeach;
                        endif;
                
                    # Trick....
                    $IDS = array_unique($IDS);
                    return $IDS;
    }
    
    private function category_content_set_cookie($cat){
            @setcookie('category_content', $cat, time()+60*60*24*30, '/');
    }
    
    # Create HTML select dropdown with the years posts were published
    private function year_list($current_setting){
        global $wpdb;
        $available_years = $wpdb->get_results($wpdb->prepare("SELECT DISTINCT(YEAR(post_date)) from {$wpdb->prefix}posts"), ARRAY_N);
        $list = '';
            foreach ($available_years as $a1){
                foreach ($a1 as $a2){
                    if ($current_setting == $a2){
                        $list .= '<option value="'.$a2.'" selected="selected">'.$a2.'</option>';
                    } else {
                        $list .= '<option value="'.$a2.'" >'.$a2.'</option>';
                    }
                }
            }
            return $list;
    }

	function update( $new_instance, $old_instance )
	{
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
        $instance['show_on'] = strip_tags( $new_instance['show_on'] );
		$instance['show_cats'] = strip_tags( $new_instance['show_cats'] );  
		$instance['amount'] = strip_tags( $new_instance['amount'] );
		$instance['orderby_cat'] = strip_tags( $new_instance['orderby_cat'] );
        $instance['orderby_single'] = strip_tags( $new_instance['orderby_single'] );
		$instance['order_cat'] = strip_tags( $new_instance['order_cat'] );
        $instance['order_single'] = strip_tags( $new_instance['order_single'] );
		$instance['remove_childs'] = strip_tags( $new_instance['remove_childs'] );
        $instance['show_year'] = strip_tags( $new_instance['show_year'] );
        $instance['exclude_cats'] = strip_tags( $new_instance['exclude_cats'] );
        $instance['exclude_on'] = strip_tags( $new_instance['exclude_on'] );
        $instance['show_last_viewed_cat'] = strip_tags( $new_instance['show_last_viewed_cat'] );
        $instance['sticky_posts_on_top'] = strip_tags( $new_instance['sticky_posts_on_top'] );
      
		return $instance;
	}

	function form( $instance )
	{
		$instance = wp_parse_args( ( array )$instance, array( 
                                        'title' => 'More',
                                        'show_on' => 'single',
                                        'show_cats' => 'yes', 
                                        'amount' => 10,
                                        'orderby_single' => 'rand', 
                                        'orderby_cat' => 'rand',
                                        'order_single' => 'DESC',
                                        'order_cat' => 'DESC', 
                                        'remove_childs' => 'off',
                                        'show_year' => '%',
                                        'exclude_cats' => '',
                                        'exclude_on' => 'none',
                                        'show_last_viewed_cat' => 'no',
                                        'sticky_posts_on_top' => 'no'
                                       ) 
                                        );
                                        
		$title = strip_tags( $instance['title'] );
        $show_on = strip_tags( $instance['show_on'] );
        $show_cats = strip_tags( $instance['show_cats'] );
		$amount = strip_tags( $instance['amount'] );
		$orderby_single = strip_tags( $instance['orderby_single'] );
        $orderby_cat = strip_tags( $instance['orderby_cat'] );
        $order_single = strip_tags( $instance['order_single'] );
        $order_cat = strip_tags( $instance['order_cat'] );
		$remove_childs = strip_tags( $instance['remove_childs'] );
        $show_year = strip_tags( $instance['show_year'] );
        $exclude_cats = strip_tags( $instance['exclude_cats'] );
        $exclude_on = strip_tags( $instance['exclude_on'] );
        $show_last_viewed_cat = strip_tags( $instance['show_last_viewed_cat'] );
        $sticky_posts_on_top = strip_tags($instance['sticky_posts_on_top']);
        
        ?>
			<p><label for="<?php echo $this->get_field_id( 'title' ); ?>">Title <small>(before the category name(s))</small>:<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo attribute_escape( $title ); ?>" /></label></p>
            <p><label for="<?php echo $this->get_field_id( 'exclude_cats' ); ?>">Exclude category(s) by ID: <input class="widefat" id="<?php echo $this->get_field_id( 'exclude_cats' ); ?>" name="<?php echo $this->get_field_name( 'exclude_cats' ); ?>" type="text" value="<?php echo attribute_escape( $exclude_cats ); ?>" /><small>Separate multiple categories with commas</small></label></p>
            <p><label for="<?php echo $this->get_field_id( 'exclude_on' ); ?>">Exclude categories on: <select class="widefat" id="<?php echo $this->get_field_id( 'exclude_on' ); ?>" name="<?php echo $this->get_field_name( 'exclude_on' ); ?>">
																					<option value="none" <?php if ( $exclude_on == 'none' ) echo 'selected="selected"'; ?>>Do not exclude anything</option>
                                                                                    <option value="single" <?php if ( $exclude_on == 'single' ) echo 'selected="selected"'; ?>>Single posts</option>
                                                                                    <option value="category" <?php if ( $exclude_on == 'category' ) echo 'selected="selected"'; ?>>Category pages</option>
																					<option value="both" <?php if ( $exclude_on == 'both' ) echo 'selected="selected"'; ?>>Single posts and category pages</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'sticky_posts_on_top' ); ?>">Sticky posts on top: <select class="widefat" id="<?php echo $this->get_field_id( 'sticky_posts_on_top' ); ?>" name="<?php echo $this->get_field_name( 'sticky_posts_on_top' ); ?>">
                                                                                    <option value="yes" <?php if ( $sticky_posts_on_top == 'yes' ) echo 'selected="selected"'; ?>>Yes</option>
																					<option value="no" <?php if ( $sticky_posts_on_top == 'no' ) echo 'selected="selected"'; ?>>No</option>
																					</select>
																					</label>
																					</p>
            <p><label for="<?php echo $this->get_field_id( 'show_year' ); ?>">Show posts from year: <select class="widefat" id="<?php echo $this->get_field_id( 'show_year' ); ?>" name="<?php echo $this->get_field_name( 'show_year' ); ?>">
																					<option value="%" <?php if ( $show_year == '%' ) echo 'selected="selected"'; ?>>Show posts from all years</option>
                                                                                    <?php echo $this->year_list($show_year); ?>
																					</select>
																					</label>
																					</p>
            <p><label for="<?php echo $this->get_field_id( 'show_on' ); ?>">Show widget on: <select class="widefat" id="<?php echo $this->get_field_id( 'show_on' ); ?>" name="<?php echo $this->get_field_name( 'show_on' ); ?>">
																					<option value="single" <?php if ( $show_on == 'single' ) echo 'selected="selected"'; ?>>Single posts</option>
                                                                                    <option value="category" <?php if ( $show_on == 'category' ) echo 'selected="selected"'; ?>>Category pages</option>
																					<option value="both" <?php if ( $show_on == 'both' ) echo 'selected="selected"'; ?>>Single posts and category pages</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'show_cats' ); ?>">Show category title(s): <select class="widefat" id="<?php echo $this->get_field_id( 'show_cats' ); ?>" name="<?php echo $this->get_field_name( 'show_cats' ); ?>">
                                                                                    <option value="yes" <?php if ( $show_cats == 'yes' ) echo 'selected="selected"'; ?>>Yes</option>
																					<option value="no" <?php if ( $show_cats == 'no' ) echo 'selected="selected"'; ?>>No</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'show_last_viewed_cat' ); ?>">Post has multiple categories - what now: <select class="widefat" id="<?php echo $this->get_field_id( 'show_last_viewed_cat' ); ?>" name="<?php echo $this->get_field_name( 'show_last_viewed_cat' ); ?>">
                                                                                    <option value="yes" <?php if ( $show_last_viewed_cat == 'yes' ) echo 'selected="selected"'; ?>>Show the last category viewed</option>
																					<option value="no" <?php if ( $show_last_viewed_cat == 'no' ) echo 'selected="selected"'; ?>>Show all categories</option>
																					</select><small>In case a post has multiple categories</small><br /><small>!!!Uses cookies!!!</small>
																					</label>
																					</p>                                                                                			
            <p><label for="<?php echo $this->get_field_id( 'amount' ); ?>">Show how many posts: <input class="widefat" id="<?php echo $this->get_field_id( 'amount' ); ?>" name="<?php echo $this->get_field_name( 'amount' ); ?>" type="text" value="<?php echo attribute_escape( $amount ); ?>" />-1 for all posts</label></p>
			<p><label for="<?php echo $this->get_field_id( 'orderby_single' ); ?>">Single post view - Orderby: <select class="widefat" id="<?php echo $this->get_field_id( 'orderby_single' ); ?>" name="<?php echo $this->get_field_name( 'orderby_single' ); ?>">
																					<option value="author" <?php if ( $orderby_single == 'author' ) echo 'selected="selected"'; ?>>Author</option>
																					<option value="date" <?php if ( $orderby_single == 'date' ) echo 'selected="selected"'; ?>>Date</option>
																					<option value="ID" <?php if ( $orderby_single == 'ID' ) echo 'selected="selected"'; ?>>ID</option>
																					<option value="rand" <?php if ( $orderby_single == 'rand' ) echo 'selected="selected"'; ?>>Random</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'order_single' ); ?>">Single posts view - Order: <select class="widefat" id="<?php echo $this->get_field_id( 'order_single' ); ?>" name="<?php echo $this->get_field_name( 'order_single' ); ?>">
																					<option value="ASC" <?php if ( $order_single == 'ASC' ) echo 'selected="selected"'; ?>>Ascending</option>
																					<option value="DESC" <?php if ( $order_single == 'DESC' ) echo 'selected="selected"'; ?>>Descending</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'orderby_cat' ); ?>">Category view - Orderby: <select class="widefat" id="<?php echo $this->get_field_id( 'orderby_cat' ); ?>" name="<?php echo $this->get_field_name( 'orderby_cat' ); ?>">
																					<option value="author" <?php if ( $orderby_cat == 'author' ) echo 'selected="selected"'; ?>>Author</option>
																					<option value="date" <?php if ( $orderby_cat == 'date' ) echo 'selected="selected"'; ?>>Date</option>
																					<option value="ID" <?php if ( $orderby_cat == 'ID' ) echo 'selected="selected"'; ?>>ID</option>
																					<option value="rand" <?php if ( $orderby_cat == 'rand' ) echo 'selected="selected"'; ?>>Random</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'order_cat' ); ?>">Category view - Order: <select class="widefat" id="<?php echo $this->get_field_id( 'order_cat' ); ?>" name="<?php echo $this->get_field_name( 'order_cat' ); ?>">
																					<option value="ASC" <?php if ( $order_cat == 'ASC' ) echo 'selected="selected"'; ?>>Ascending</option>
																					<option value="DESC" <?php if ( $order_cat == 'DESC' ) echo 'selected="selected"'; ?>>Descending</option>
																					</select>
																					</label>
																					</p>
			<p><label for="<?php echo $this->get_field_id( 'remove_childs' ); ?>">Remove child categories: <select class="widefat" id="<?php echo $this->get_field_id( 'remove_childs' ); ?>" name="<?php echo $this->get_field_name( 'remove_childs' ); ?>">
																					<option value="on" <?php if ( $remove_childs == 'on' ) echo 'selected="selected"'; ?>>Remove child cats</option>
																					<option value="off" <?php if ( $remove_childs == 'off' ) echo 'selected="selected"'; ?>>Dont remove child cats</option>
																					</select>
																					</label>
																					</p>
<?php }

}

add_action( 'widgets_init', 'RegisterCategoryContent' );

function RegisterCategoryContent()
{
	register_widget( 'CategoryContent' );
}
ob_get_contents();?>